C     ******************************************************
C
C     PROGRAM PLOTPOW.FOR :PLOT POWDER DIFFRACTION PATTERNS
C
C     VERSION November 1990 - J.RODRIGUEZ CARVAJAL
C     CURRENT DIMENSION : NPUNTO=8192 POINTS
C     TO LOAD THE PROGRAM ,DO :
C     LINK PLOTPOW,COMDATA:SPELIB/L,ILLLIB:GRLIB/L,NAG/L,
C              GKSINT/L,GKSBX/L,BENLIB/L
C
C     ******************************************************
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C
      PARAMETER (NPUNTO=8192,NREFLE=4096)
      CHARACTER BLK*1
      CHARACTER DTEX*7,NSX*14,NTX*28,NTY*20,TITLP*40,DTEXX*28
      CHARACTER NDEV*1
      CHARACTER ANSDEV*1,ANSWRD*1,ANSWER*1,ANSTEK*1
      CHARACTER ANS*1
      CHARACTER FILEN1*16
      INTEGER ESC,GS,CAN
      REAL*4 Y(NPUNTO),X(NPUNTO),YC(NPUNTO),AUXX(NPUNTO),AUXY(NPUNTO)
      REAL*4 YCC(NPUNTO),AUXYCC(NPUNTO)
      REAL*8 AX(NPUNTO),AY(NPUNTO),XMIN,XMAX,YMIN,YMAX
      REAL*8 AYC(NPUNTO),AYCC(NPUNTO)
      INTEGER TTY
      DIMENSION DTEX(4),ANSWER(3),ANSWRD(3),DTEXX(3),AUXYC(NPUNTO)
      DATA ESC,GS,CAN/27,29,24/
      DATA ANSWER/'T','Q','D'/
      DATA ANSWRD/'T','L','B'/
      DATA NSX/'2-THETA       '/
      DATA NTY/'     INTENSITY      '/
      DATA DTEX/'2-Theta','   Q   ',' D(A)  ','       '/
      DATA DTEXX/'        2-THETA             ',
     $           '  Q=4*PI*SIN(THETA)/LAMBDA  ',
     $           '      D - ANGSTROMS         '/
      DATA PI/3.141592654/,RAD/57.29577951/
      COMMON/RANG/THMIN,STEP,THMAX
      COMMON/DAT1/X,Y,YC,YCC
      COMMON/PLOT/NPTS,XMIN,XMAX,YMIN,YMAX,AX,AY,AYC,AYCC,NTX,NTY,TITLP
      COMMON/JNK/IVERS,NEXC,ALOW(30),AHIGH(30),DIFM,KSP,TICK,ANSTEK,
     &IDIF,IADDP,XT,YT,IOB,IFFAX
      COMMON/REFLS/NREF,NPHASE,IREFS(NREFLE),REFS(NREFLE),IC(8)
      BLK=' '
C
C   SOME DEFAULT VALUES
C
      XLA=2.52
      ICORR=0
      MODIFX=0
      TTY=5
      DIFM=4.8
      XT=22.5
      YT=16.95
      KSP=2
      TICK=5.0
      IDIF=1
      IOB=1
C
C_____________________________________________________________________
C
      TYPE*,'     '
      TYPE*,'     '
      TYPE*,'     '
      TYPE*,'     '
      TYPE*,'          ******   PROGRAM PLOTPOW   ******* '
      TYPE*,'      '
      TYPE*,'   Laser/Tektro Plots of Powder Diffraction Patterns  '
      TYPE*,'     '
      TYPE*,'            (Version November 1990-JRC) '
      TYPE*,'     '
      TYPE*,' '
      TYPE*,'  '
 198  TYPE*,'  Name of the intensity file '
      ACCEPT 200,FILEN1
 200  FORMAT(A16)
      OPEN(UNIT=21,NAME=FILEN1,TYPE='OLD',ERR=199,READONLY)
      GOTO 197
 199  TYPE*,'  File not found !!'
      GOTO 198
 197  TYPE*,'     '
      TYPE*,'     '
      TYPE*,'  Type of intensity data:'
      TYPE*,'     '
      TYPE*,'     '
      TYPE*,'             1  -  EXPERIMENTAL DATA'
      TYPE*,'             2  -  FROM PAWLEY PROGRAM'
      TYPE*,'             3  -  FROM FULLPROF PROGRAM'
      TYPE*,'             4  -  FROM NEUFIT/XRFIT PROGRAM'
      TYPE*,'             5  -  FROM ARIT PROGRAM'
      TYPE*,'             6  -  FROM PROF2(BNL) PROGRAM'
      TYPE*,'             7  -  FROM MAGCAL PROGRAM'
      TYPE*,'             8  -  FROM DIFFaX PROGRAM'
      TYPE*,'             9  -  2THETA, IOBS, ICALC (Free Format)'
      TYPE*,'     '
      TYPE*,'     '
      READ(*,*,ERR=197)ITYPE
      TYPE*,'     '
      IF(ITYPE.LT.1.OR.ITYPE.GT.9) THEN
        TYPE*,'  Invalid option !!! '
        GOTO 197
      END IF
      IF(ITYPE.EQ.1) THEN
       IGRID=0
       WRITE(*,'(A)')'  Draw a grid (y/n)? <CR>=N '
       READ(*,'(A)') ANS
      IF(ANS.EQ.'Y'.OR.ANS.EQ.'y') IGRID=1
      ENDIF
      CALL INPUT(ITYPE,NPUN)
      CLOSE(UNIT=21)
      IF(ITYPE.EQ.8) THEN
        DIFM=0.1
        IF(IFFAX.EQ.1) THEN
 333       WRITE(*,'(A)')'  Plot: resolution-free data (1)'
           WRITE(*,'(A)')'        broadened data (2)'
           WRITE(*,'(A)')'        both (3)'
           READ(*,*,ERR=333) IDFAX
           IF(IDFAX.LT.1.OR.IDFAX.GT.3) GOTO 333
        ENDIF
         IFFAX=IDFAX
      ENDIF
        NPTS=NPUN
        XMIN=THMIN
        XMAX=THMAX
C***************************************************************************
C      Prepare graphics
C
C*************************************************************************
C
 8207 WRITE(TTY,2001)
 2001 FORMAT(2X,'Type of plot (T/Q/D/N/?) ?')
      READ(TTY,2002)ANSTEK
      IF(ANSTEK.EQ.BLK.OR.ANSTEK.EQ.'t')ANSTEK='T'
      IF(ANSTEK.EQ.'N'.OR.ANSTEK.EQ.'n')GOTO 11000
      IF(ANSTEK.EQ.'?')WRITE(TTY,2008)
      IF(ANSTEK.EQ.'q') ANSTEK='Q'
      IF(ANSTEK.EQ.'d') ANSTEK='D'
 2008 FORMAT(2X,'Possible answers: T = Plot with 2-THETA scale'/
     121X,'Q = Plot with Q scale'/
     221X,'D = Plot with D scale'/
     321X,'N = Dont prepare any plot'/
     421X,'? = Type this message')
      DO 2010 J=1,3
      IF(ANSTEK.EQ.ANSWER(J))GOTO 2030
 2010 CONTINUE
      GOTO 8207
 2030  WRITE(TTY,2020)
 2020 FORMAT(2X,'Output device (T/L/?) ?')
      READ(TTY,2002)ANSDEV
      IF(ANSDEV.EQ.BLK.OR.ANSDEV.EQ.'t')ANSDEV='T'
      IF(ANSDEV.EQ.'B'.OR.ANSDEV.EQ.'b')ANSDEV='T'
      IF(ANSDEV.EQ.'l')ANSDEV='L'
      DO 2040 JD=1,3
      IF(ANSDEV.EQ.ANSWRD(JD))GOTO 2003
 2040 CONTINUE
      WRITE(TTY,2028)
 2028 FORMAT(2X,'Possible answers : T = Tektronix plot'/
     121X,'L = Laser print'/
     321X,'? = Type this message')
      GOTO 2060
 2003 WRITE(TTY,2005)
 2005 FORMAT(2X,'Give a title for plot (30 CHARACTERS) :')
      READ(TTY,2006)TITLP
 2006 FORMAT(A)
C
C      ENTER WAVELENGTH IF NEEDED (OPTIONS Q & D)
C
      NANS=1
      DO 2007 J=1,3
      IF(ANSTEK.EQ.ANSWER(J))GOTO(2503,2504,2505),J
 2007 CONTINUE
 2504 WRITE(TTY,4448)
 4448 FORMAT(2X,'Which wavelength (If 0 then lambda=2.52)')
      READ(TTY,*)XLAMB
      IF(XLAMB.EQ.0.0)XLAMB=XLA
C
C     MODIFY X SCALE FROM 2-THETA TO Q VALUES
C          Q=4.*PI*SIN(THETA)/LAMBDA
C
      NANS=2
      DO 2501 I=1,NPTS
 2501 X(I)=4.*PI*SIN(0.5*X(I)/RAD)/XLAMB
      XMIN=X(1)
      XMAX=X(NPTS)
      QMIN=XMIN
      QMAX=XMAX
      IF(ITYPE.EQ.1) GOTO 2503
      DO I=1,NEXC
      ALOW(I)=4.*PI*SIN(0.5*ALOW(I)/RAD)/XLAMB
      AHIGH(I)=4.*PI*SIN(0.5*AHIGH(I)/RAD)/XLAMB
      END DO
      DO  I=1,NREF
      REFS(I)=4.*PI*SIN(0.5*REFS(I)/RAD)/XLAMB
      END DO
      GOTO 2503
 2505 WRITE(TTY,4448)
      READ(TTY,*)XLAMB
      IF(XLAMB.EQ.0.0)XLAMB=XLA
C
C     MODIFY X SCALE FROM 2-THETA TO D VALUES
C          D=0.5*LAMBDA/SIN(THETA)
C
      NANS=3
      DO 2506 I=1,NPTS
      J=NPTS-I+1
      AUXY(J)=Y(I)
      AUXYC(J)=YC(I)
      IF(IADDP.EQ.1) AUXYCC(J)=YCC(I)
 2506 AUXX(J)=0.5*XLAMB/SIN(0.5*X(I)/RAD)
      DO I=1,NPTS
        Y(I)=AUXY(I)
        YC(I)=AUXYC(I)
        X(I)=AUXX(I)
      IF(IADDP.EQ.1) YCC(I)=AUXYCC(I)
      END DO
      XMIN=X(1)
      XMAX=X(NPTS)
      DMIN=XMIN
      DMAX=XMAX
      IF(ITYPE.EQ.1) GOTO 2503
      DO I=1,NEXC
      J=NEXC-I+1
      IF(ALOW(I).LT.0.1.OR.ALOW(I).GT.179.9) THEN
       AUXX(J)=100.0
       ELSE
      AUXX(J)=0.5*XLAMB/SIN(0.5*ALOW(I)/RAD)
       END IF
      IF(AHIGH(I).LT.0.1.OR.AHIGH(I).GT.179.9) THEN
      AUXY(J)=100.0
       ELSE
      AUXY(J)=0.5*XLAMB/SIN(0.5*AHIGH(I)/RAD)
       ENDIF
      END DO
        DO I=1,NEXC
        ALOW(I)=AUXX(I)
        AHIGH(I)=AUXY(I)
        END DO
      DO  I=1,NREF      
      J=NREF-I+1
      AUXX(J)=0.5*XLAMB/SIN(0.5*REFS(I)/RAD)
      AUXY(J)=IREFS(I)
      END DO
      DO I=1,NREF
      REFS(I)=AUXX(I)
      IREFS(I)=AUXY(I)
      END DO
C
C     FIND MINIMUM AND MAXIMUM OF Y
C
 2503 XMI=XMIN
      XMA=XMAX
      NTX=DTEXX(NANS)
      YMI=1000000.
      YMA=0.
      IF(NANS.EQ.1) THEN
        XMII=XMI
        XMAA=XMA
      ENDIF
      IF(NANS.EQ.2) THEN
        XMII=2.0*RAD*ASIN(0.25*XMI*XLAMB/PI)
        XMAA=2.0*RAD*ASIN(0.25*XMA*XLAMB/PI)
      ENDIF
      IF(NANS.EQ.3) THEN
        XMII=2.0*RAD*ASIN(0.5*XLAMB/XMA)
        XMAA=2.0*RAD*ASIN(0.5*XLAMB/XMI)
      ENDIF
             N1=(XMII-THMIN)/STEP+1.5
             N2=(XMAA-THMIN)/STEP+1.5
      IF(NANS.EQ.3) THEN
       NF=N1
       NI=N2
       N1=NPUN-NI+1
       N2=NPUN-NF+1
      END IF
      NPTS=N2-N1+1
      DO I=N1,N2
          IF(Y(I).GT.YMA) YMA=Y(I)
          IF(Y(I).LT.YMI.AND.Y(I).NE.0..AND.Y(I).NE.1.0) YMI=Y(I)
      END DO
      IF(ITYPE.EQ.1) GOTO 527
      DO I=N1,N2
          IF(YC(I).GT.YMA) YMA=YC(I)
      END DO
  527 CONTINUE
      YMIN=YMI
C      YMAX=YMA+SQRT(ABS(YMA))
      YMAX=YMA
      IF(ITYPE.EQ.1) THEN
      WRITE(TTY,208)DTEX(NANS),XMIN,DTEX(NANS),XMAX,YMI,YMA
  208 FORMAT(2X,'Minimum ',A5,' = ',F7.3/
     12X,'Maximum ',A5,' = ',F7.3/
     22X,'Minimum intensity = ',F10.0/
     32X,'Maximum intensity = ',F10.0)
      ELSE
      WRITE(TTY,208)DTEX(NANS),XMIN,DTEX(NANS),XMAX,YMI,YMA
      IF(ICORR.NE.0) GOTO 271    
         ICORR=1
      WRITE(TTY,'(A)') '  Correct for a constant background (<CR>=N)? '
      WRITE(TTY,'(A)') '         (Icorr= I - Imin) '
      READ(TTY,2002) ANS
      IF(ANS.EQ.'Y'.OR.ANS.EQ.'y') THEN
       DO I=1,NPTS
       Y(I)=Y(I)-YMI
       YC(I)=YC(I)-YMI
      IF(IADDP.EQ.1) YCC(I)=YCC(I)-YMI
       IF(Y(I).LT.0.) Y(I)=0.
       IF(YC(I).LT.0.) YC(I)=0.
       END DO
         GOTO 2503
        ENDIF
  271 CONTINUE
C     WRITE(TTY,1208)DTEX(NANS),XMIN,DTEX(NANS),XMAX
C 1208 FORMAT(2X,'Minimum ',A5,' = ',F7.3/
C     12X,'Maximum ',A5,' = ',F7.3/)
      ENDIF
      IF(MODIFX.EQ.1) GOTO 2121
      WRITE(TTY,201)
  201 FORMAT(2X,'Modify X-Limits (<CR>=N) ?')
      READ(TTY,2002)ANS
 2002 FORMAT(A1)
      IF(ANS.EQ.BLK.OR.ANS.EQ.'n')ANS='N'
      IF(ANS.EQ.'N')GO TO 2121
C
C     MODIFY LIMITS OF PLOT
C
 3200 MODIFX=1
      WRITE(TTY,203)DTEX(NANS)
  203 FORMAT(2X,'Give ',A7,' Limits (Original scale=0 0) :')
      READ(TTY,*)XMI,XMA
      TEST1=ABS(XMI)+ABS(XMA)
      IF(TEST1.EQ.0.)GO TO 2121
      IF(XMI.LT.THMIN.AND.NANS.EQ.1) XMI=THMIN
      IF(XMA.GT.THMAX.AND.NANS.EQ.1) XMA=THMAX
      IF(XMI.LT.QMIN.AND.NANS.EQ.2) XMI=QMIN
      IF(XMA.GT.QMAX.AND.NANS.EQ.2) XMA=QMAX
      IF(XMI.LT.DMIN.AND.NANS.EQ.3) XMI=DMIN
      IF(XMA.GT.DMAX.AND.NANS.EQ.3) XMA=DMAX
      XMIN=XMI
      XMAX=XMA
      GOTO 2503
 2121 MODIFX=0
C 3201 IF(ITYPE.GT.1) CALL CHANGE
 3201 TYPE*,' Modify Y-scale limits (<CR>=N) ?'
      READ(TTY,2002)ANS
      IF(ANS.EQ.BLK.OR.ANS.EQ.'n')ANS='N'
      IF(ANS.EQ.'N')GO TO 210
 2120 WRITE(TTY,204)
  204 FORMAT(2X,'Give Y-scale Limits (Original scale=0 0) :')
      READ(TTY,*)YMI,YMA
      TEST2=ABS(YMI)+ABS(YMA)
      IF(TEST2.EQ.0.)GO TO 210
      YMIN=YMI
C      YMAX=YMA+SQRT(ABS(YMA))
      YMAX=YMA
  210 CONTINUE
C
C  The value of YMI determines the shape of the plot for obs-cal patterns
C
      IF(ITYPE.GT.1) THEN
      CALL CHANGE
      YMI=-DIFM*YMA/(YT-DIFM)
      YMIN=YMI
C      GOTO 210
      ENDIF
      DO 2300 NI=1,NPTS
      NEWI=NI+N1-1
      AX(NI)=X(NEWI)
      AY(NI)=Y(NEWI)
      AYC(NI)=YC(NEWI)
      IF(IADDP.EQ.1) AYCC(NI)=YCC(NEWI)
 2300 CONTINUE
C
C****** Call plotting routines
C
      IF(JD.EQ.1) WRITE(TTY,101) CHAR(ESC),CHAR(GS)
      CALL PLOT_2D(JD,ITYPE,IGRID)
  211 CONTINUE
      IF(ANSDEV.NE.'T')GOTO 800
 2060 WRITE(TTY,'(A)') ' -><CR>'
      READ(TTY,'(A)') ANS
      WRITE(TTY,101) CHAR(ESC),CHAR(CAN)
      WRITE(TTY,220)
  220 FORMAT(2X,'Hard copy of this plot (N/L/?) ?')
      READ(TTY,2002)NDEV
      IF(NDEV.EQ.'N'.OR.NDEV.EQ.BLK.OR.NDEV.EQ.'n')GOTO 800
      IF(NDEV.EQ.'l') NDEV='L'
      DO 2050 NJD=2,3
      IF(NDEV.EQ.ANSWRD(NJD))GOTO 2053
 2050 CONTINUE
      WRITE(TTY,2058)
 2058 FORMAT(2X,'Possible answers : N = No hard copy plot'/
     121X,'L = Laser print'/
     321X,'? = Type this message')
      GOTO 2060
 2053 CALL PLOT_2D(NJD,ITYPE,IGRID)
  800 WRITE(TTY,101) CHAR(ESC),CHAR(CAN)
      WRITE(TTY,201)
      READ(TTY,2002)ANS
      IF(ANS.EQ.'Y'.OR.ANS.EQ.'y') GO TO 3200
      WRITE(TTY,'(/A)') '  Continue with the same plot (<CR>=N)?' 
      READ(TTY,2002)ANS
      IF(ANS.EQ.'Y'.OR.ANS.EQ.'y') GO TO 3201
      WRITE(TTY,'(/A)') '  Do you want another plot (<CR>=N)?' 
      READ(TTY,2002)ANS
      IF(ANS.EQ.'Y'.OR.ANS.EQ.'y')GO TO 198
11000 STOP
  101 FORMAT(2A)
      END
C
C******************************************************************************
C
C     *******************************************
C
      SUBROUTINE PLOT_2D(DEVICE,ICAL,IGRID)
C
C     *******************************************
C
C
C  LINK PLOT_2D,ILLLIB:GRLIB/L,NAG/L,GKSINT/L,GKSBX/L,BENLIB/L
C
        PARAMETER(NPUNTO=8192,NREFLE=4096)
      DIMENSION      IPEN(4),ICOL(4),ILSTYL(4),ITYP(3),ICONID(3)
      DIMENSION      IFONT(4)
      CHARACTER      TITLE*40,ANSTEK*1
      CHARACTER      LABELONX*28,
     &                  LABELONY*20
        INTEGER DEVICE
      DOUBLE PRECISION XMIN,XMAX,YMIN,YMAX
      DOUBLE PRECISION UMIN,UMAX,VMIN,VMAX
      DOUBLE PRECISION AX(NPUNTO),AY(NPUNTO)
      DOUBLE PRECISION AYC(NPUNTO),DIF(NPUNTO),AYCC(NPUNTO)
      DOUBLE PRECISION BX(2),BY(2),SHIFT,XL,YL
C
C External subroutines
C
      EXTERNAL      J06ABF,J06ADF,J06AEF,J06AHF,J06AJF,
     &                  J06BAF,J06CAF,J06WAF,J06WBF,J06WCF,J06AGF,
     &                  J06WDF,J06WZF,J06XFF,J06YMF,X04AAF,X04BAF,
     &                  GOPKS,GOPWK,GACWK,GCLKS,GCLWK,GDAWK,
     &                  J06YAF,J06YCF,J06YGF,J06YJF  ! Primitives
C
C
C Common block to transfer data
C
      COMMON/PLOT/N,XMIN,XMAX,YMIN,YMAX,AX,AY,AYC,AYCC,LABELONX,
     1LABELONY,TITLE
      COMMON/JNK/IVERS,NEXC,ALOW(30),AHIGH(30),DIFM,KSP,TICK,ANSTEK,
     &IDIF,IADDP,XT,YT,IOB,IFFAX
      COMMON/REFLS/NREF,NPHASE,IREFS(NREFLE),REFS(NREFLE),IC(8)
C
      DATA      ITYP/4014,3333,132/
      DATA      ICONID/6,33,32/
      DATA      RX,RY            /4094.,3050./
      DATA      IPEN/1,2,3,4/ICOL/1,2,3,4/ILSTYL/3,1,1,1/
      DATA      IFONT/11,11,11,4/
      RATIO = RY/RX
        BEX=RX/1.0
        BEY=RY/1.0
        ICO=ICONID(DEVICE)
        IT=ITYP(DEVICE)
        XL=XMAX-XMIN
        YL=YMAX-YMIN
C
C  Pen attributes
C            IPEN       ICOL          ILSTYL   IFONT
C            __________________________________________
C             1        1(red)          3         11
C             2        2(green)        1         11
C             3        3(black)        1         11
C             4        4(black)        1         4
C
C Select output channel for any error message generated
C
      CALL      X04AAF(1,NOUT)
C
C Open GKS
C
      CALL      GOPKS(2)  ! the FOR002.DAT file will store the errors
C
C
C   Open WK 1 (TEKTRONIX 4014) , WK 2 (LASER) OR WK 3 (BENSON)
C
      CALL GOPWK(1,ICO,IT)
      CALL GACWK(1)
C
C Calculate the centered title,label on X,label on Y
C
      CALL      CENTER(TITLE)
      CALL      CENTER(LABELONX)
      CALL      CENTER(LABELONY)
C
C Initialise NAG GRAPHICAL SUPPLEMENT
C
      CALL      J06WAF
C
C Define the pen attributes
C
      DO I = 1,4
         CALL      J06XDF(IPEN(I),ICOL(I),ILSTYL(I),IFONT(I))
      END DO
C
C Map data region onto viewport
C
      MARGIN=1
      CALL      J06WBF(XMIN,XMAX,YMIN,YMAX,MARGIN)
C
      GOTO(501,501,502),DEVICE
C
C Define wiewport to use the entire display area
C            (on both 4014 , LASER )
  501 IF(XT.EQ.22.5) THEN
      UMIN=0.0
      UMAX=1.0
       ELSE
      UU=XT/22.5
      UMIN=0.5*(1.0-UU)
      IF(UMIN.LT.0.0) UMIN=0.0
      UMAX=UMIN+UU
      IF(UMAX.GT.1.0) UMAX=1.0
      END IF
      IF(YT.EQ.16.95) THEN
      VMIN=0.0
      VMAX=RATIO
       ELSE
      VV=RATIO*YT/16.95
      VMIN=0.5*(RATIO-VV)
      IF(VMIN.LT.0.0) VMIN=0.0
      VMAX=VMIN+VV
      IF(VMAX.GT.RATIO) VMAX=RATIO
      ENDIF
         GOTO 510
  502   WRITE(5,517)
  517   FORMAT(2X,' BENSON PLOT NOT AVAILABLE ')
        STOP
  510   CALL      J06WCF(UMIN,UMAX,VMIN,VMAX)
C
C      Define WK 1 window in NDC
C
  401 CALL      GSWKWN(1,0.,1.,0.,RATIO)
C
C      Define WK 1 viewport in DC
C
      CALL      GSWKVP(1,0.,RX,0.,RY)
C
C  Activate WK 1
C
      CALL      GACWK(1)
C
C Select character/marker high quality as a function of device
C
      IF(DEVICE.EQ.2) THEN
        IQUAL=1
        ILSF=3
      ELSE
        IQUAL=2
        ILSF=4
      ENDIF
      CALL      J06XFF(IQUAL)
C
C Define color line style and font
C
      CALL      J06YMF(IPEN(ILSF))
C
C Draw the centered title on the current data region
C
      CALL      J06AHF(TITLE)
C
C Draw the centered X label
C
      IAXIS=1
      CALL      J06AJF(IAXIS,LABELONX)
C
C Draw the centered Y label
C
      IAXIS=2
      CALL      J06AJF(IAXIS,LABELONY)
C
C Define color line style and font to draw a grid
C
        IF(ICAL.NE.1) GOTO 1002
      I = 1
      CALL      J06YMF(IPEN(I))
C Draw a grid
      IF(IGRID.EQ.0) GOTO 1002
      DX=0
      DY=0
      CALL      J06ADF(DX,DY)
C
C Define color line style and font
C
 1002    CALL      J06YMF(IPEN(ILSF))
C
C Draw a scaled border with tick marks
C
      CALL       J06AEF
C
C Enhance the border
C
C        BX(1)=XMIN                       !Horizontal low line 
C        BX(2)=XMAX
C        BY(1)=YMIN+YL/1000.0
C        CALL J06YAF(BX(1),BY(1))
C        CALL J06YCF(BX(2),BY(1))
C        BX(1)=XMIN                       !Horizontal high line 
C        BX(2)=XMAX
C        BY(1)=YMAX-YL/1000.0
C        CALL J06YAF(BX(1),BY(1))
C        CALL J06YCF(BX(2),BY(1))
C        BX(1)=XMIN+XL/1500.0     !Vertical left line 
C        BY(1)=YMAX
C        BY(2)=YMIN
C        CALL J06YAF(BX(1),BY(1))
C        CALL J06YCF(BX(1),BY(2))
C        BX(1)=XMAX-XL/1500.0     !Vertical right line 
C        BY(1)=YMAX
C        BY(2)=YMIN
C        CALL J06YAF(BX(1),BY(1))
C        CALL J06YCF(BX(1),BY(2))
C      
      IF(ANSTEK.EQ.'Q'.OR.ANSTEK.EQ.'D') GOTO 170
C
C Draw small tick marks for 2Theta axis
C
      INI=INT(XMIN*10.0)
      IFI=INT(XMAX*10.0)
      ITICK=INT(TICK*10.0)
      SHIFT=YL/80.0+YMIN
      DO 171 I=INI,IFI
	IF(MOD(I,ITICK).NE.0) GOTO 171
        BX(1)=DFLOAT(I)/10.0D0
        CALL J06YAF(BX(1),SHIFT)
        CALL J06YCF(BX(1),YMIN)
 171  CONTINUE
C
C       ITYPE=0            ! symbols only
 170  IF(ICAL.GT.1) GOTO 1234
C
C        EXPERIMENTAL DATA AS BLACK CONTINOUS-LINE
C
        CALL J06YAF(AX(1),AY(1))     ! Moves cursor to the first position
        DO 184 I=2,N
        AAY=AY(I)
        IF(AAY.GT.YMAX) AAY=YMAX
        IF(AAY.LT.YMIN) AAY=YMIN
        CALL J06YCF(AX(I),AAY)
  184   CONTINUE
      IF(YMIN.LT.0.0) THEN               ! IF DIFFERENCE PATTERN Y=0 LINE
        CALL J06YAF(XMIN,0.0)
        CALL J06YCF(XMAX,0.0)
      ENDIF 
      GOTO 1001
C
C       DRAW CALCULATED, OBSERVED AND DIFERENCE PATTERN
C

1234  CONTINUE
      IF(ICAL.EQ.8.AND.IFFAX.LE.1) GOTO 172
      ITYPE=1
      IFAIL=10
      KSYM=1
C
C    CALCULATED PATTERN CONTINUOUS LINE
C
        CALL J06YAF(AX(1),AYC(1))     ! Moves cursor to the first position
        DO 194 I=2,N
        IF(AYC(I).LT.0.001.OR.AYC(I-1).LT.0.001) GOTO 193
        AAY=AYC(I)
        IF(AAY.GT.YMAX) AAY=YMAX
        CALL J06YCF(AX(I),AAY)
        GOTO 194
  193   CALL J06YAF(AX(I),AYC(I))
  194   CONTINUE
C
C   FURTHER CALCULATED PATTERN CONTINUOUS LINE
C
        IF(IADDP.EQ.1) THEN
        CALL J06YAF(AX(1),AYCC(1))     ! Moves cursor to the first position
        DO 5194 I=2,N
        IF(AYCC(I).LT.0.001.OR.AYCC(I-1).LT.0.001) GOTO 5193
        AAY=AYCC(I)
        IF(AAY.GT.YMAX) AAY=YMAX
        CALL J06YCF(AX(I),AAY)
        GOTO 5194
 5193   CALL J06YAF(AX(I),AYCC(I))
 5194   CONTINUE
        ENDIF
        IF(ICAL.EQ.7) GOTO 189
        IF(ICAL.EQ.8) GOTO 172
        IF(IOB.EQ.0) GOTO 191
C
C    OBSERVED PATTERN
C
        IF(KSP.NE.1) GOTO 192
        SX0=0.5*XL/DFLOAT(N-1)
        SX1=XL/225.0
        SX=AMIN1(SX1,SX0)
        SY0=YL/340.0
           DO 183 I=1,N
              IF(AY(I).GT.YMAX) GOTO 183
              SY=AMIN1(SY0,SY1)
              BY(1) = AY(I)-SY
              BY(2) = AY(I)+SY
              BX(1) = AX(I)
              BX(2) = AX(I)
              SY1=DSQRT(DABS(AY(I)))
             CALL J06BAF(BX,BY,2,ITYPE,KSYM,IFAIL)
              BX(1) = AX(I)-SX
              BX(2) = AX(I)+SX
              BY(1) = AY(I)
              BY(2) = AY(I)
             CALL J06BAF(BX,BY,2,ITYPE,KSYM,IFAIL)
  183      CONTINUE
          GOTO 191
  192   CONTINUE
C
C    OBSERVED PATTERN AS MARKER SYMBOLS
C
        SPOTSIZE=0.5*XL/DFLOAT(N-1)
        CALL J06YJF(SPOTSIZE)
        DO 190 I=2,N
        CALL J06YAF(AX(I),AY(I))     
        IF(AY(I).LT.0.001) GOTO 190
        IF(AY(I).GT.YMAX) GOTO 190
        CALL J06YGF(KSP)
  190   CONTINUE
C
C   DIFFERENCE PATTERN
C
  191   IF(IDIF.EQ.0) GOTO 189
        SHIFT=YMIN*0.66667
        DO I=1,N
           DIF(I)=AY(I)-AYC(I)+SHIFT
        END DO
        CALL J06YAF(AX(1),DIF(1))     ! Moves cursor to the first position
        DO 188 I=2,N
        IF(DIF(I).LT.YMIN) DIF(I)=YMIN
        IF(DIF(I).GT.0.0) DIF(I)=0.0
        CALL J06YCF(AX(I),DIF(I))
  188   CONTINUE
        CALL J06YAF(XMIN,SHIFT)
        CALL J06YCF(XMAX,SHIFT)
C
C   REFLECTIONS MARKERS
C
 189    IF(REFS(1).LT.0.0001) GOTO 1001
        if(idif.eq.0) then
              SY=-ABS(YMIN)*0.95/DFLOAT(NPHASE+2)
           else
              SY=-ABS(YMIN)*0.5/DFLOAT(NPHASE+2)
         endif
              SHIFT=-SY
          DO 201 J=1,NPHASE
              SHIFT=SHIFT+1.1*SY
              BY(1) = 0.9*SY+SHIFT
              BY(2) = SHIFT
           DO 202 I=1,NREF
      IF(REFS(I).GT.XMAX.OR.REFS(I).LT.XMIN) GOTO 202
         DO L=1,NEXC
          IF(REFS(I).GT.ALOW(L).AND.REFS(I).LT.AHIGH(L)) GOTO 202
         END DO
      IF(ICAL.NE.3) GOTO 334
      IF(J.NE.IREFS(I)/256/256/256/IVERS)GOTO 202
 334  IF(ICAL.NE.5) GOTO 335
      IF(IREFS(I).NE.J)GOTO 202
 335  CONTINUE
              BX(1) = REFS(I)
              BX(2) = REFS(I)
        CALL J06YAF(BX(1),BY(1))
        CALL J06YCF(BX(2),BY(2))
  202 CONTINUE
  201 CONTINUE
      GOTO 1001
C
C    ADDITIONAL PATTERN FOR ICAL=8 (DIFFaX, resolution free)
C
  172   IF(IFFAX.LE.1.OR.IFFAX.EQ.3) THEN  
        CALL J06YAF(AX(1),AY(1))     ! Moves cursor to the first position
        DO 174 I=2,N
        IF(AY(I).LT.0.00001.OR.AY(I-1).LT.0.00001) GOTO 173
        AAY=AY(I)
        IF(AAY.GT.YMAX) AAY=YMAX
        CALL J06YCF(AX(I),AAY)
        GOTO 174
  173   CALL J06YAF(AX(I),AY(I))
  174   CONTINUE
        ENDIF
C
C    END OF OBS-CAL PLOT
C
 1001   CONTINUE
C
       CALL J06YAF(XMIN,YMIN)
       CALL  GSLN(5)
C
C Terminate plotting
C
      CALL      GDAWK(1)             ! deactivate WK 1
      CALL      GCLWK(1)             ! close WK 1
      CALL      GCLKS                ! close GKS
C
        RETURN
 200      STOP      'Erreur de l''OPEN'
      END
C
C_____________________________________________________________________
C
      SUBROUTINE CENTER(TEXT)
C
C      This routine centers a text string in a (*) character field
C      in order to use the J06AHF & J06AJF NAG routines
C      X04BAZ NAG routine is used to get the number of characters
C      of the string
C
      CHARACTER*(*) TEXT
      EXTERNAL X04BAZ
      INTEGER  X04BAZ
      LN    = LEN(TEXT)   ! LN = 40 (title) or 20 (X or Y labels)
C
C Get number of characters in TEXT
C
      NCHAR = X04BAZ(TEXT)
C
C  Location of last character before moving the text
C      NCHAR
C
C Location of last character  after moving the text
C
      NPOSI = (LN+NCHAR)/2
C
C Shift the text to the right to center it in the field
C
      IF (NCHAR.LT.LN .AND. NPOSI.NE.NCHAR) THEN
        DO I = 1,NCHAR
             J = NCHAR-I+1
           K = NPOSI-I+1
           TEXT(K:K) = TEXT(J:J)      ! move character(J)
           TEXT(J:J) = ' '            ! clear
        END DO
      END IF
C
      RETURN
      END
C--------------------------------------------------------------------
      SUBROUTINE INPUT(IFORM,NPTS)
      PARAMETER (NPUNTO=8192,NREFLE=4096)
      CHARACTER NOEXP*10,JDATE*18,P1A*72,ANSTEK*1,ANS*1,FILEN1*16,TAB*1
      DIMENSION X(NPUNTO),TXT1(20),DATE(20),IWT(NPUNTO),YCC(NPUNTO)
      DIMENSION Y(NPUNTO),YC(NPUNTO),TITLE(20),VOLT(5),ICA(10),IOB(10)
      COMMON/RANG/THMIN,STEP,THMAX
      COMMON/JNK/IVERS,NEXC,ALOW(30),AHIGH(30),DIFM,KSP,TICK,ANSTEK,
     &IDIF,IADDP,XT,YT,IOBC,IFFAX
      COMMON/REFLS/NREF,NPHASE,IREFS(NREFLE),REFS(NREFLE),IC(8)
      COMMON/DAT1/X,Y,YC,YCC
      IF(IFORM.NE.1) GOTO 5000
C
C   LECTURE OF EXPERIMENTAL PATTERN
C
 197  TYPE*,'     '
      TYPE*,'     '
      TYPE*,'FORMAT OF THE RAW DATA'
      TYPE*,'     '
      TYPE*,'     '
      TYPE*,'       1  -  D1B -OLD FORMAT'
      TYPE*,'       2  -  D1A -D2B   (2THE1,STEP,2THE2 - FIRST LINE)'
      TYPE*,'       3  -  FREE FORMAT         "   "    "         "  '
      TYPE*,'       4  -  D1B,D20,...NEW FORMAT'
      TYPE*,'       5  -  LIST OF PAIRS (X,Y)'
      TYPE*,'       6  -  D1A,D2B AS PREPARED BY D1A(D2B)SUM'
      TYPE*,'       7  -  D4,D20L FORMAT '
      TYPE*,'     '
      READ(*,*,ERR=197)ITYPE
      IF(ITYPE.LT.1.OR.ITYPE.GT.7) THEN
        TYPE*,' INVALID OPTION !!! '
        GOTO 197
      ENDIF
      DO I=1,NPUNTO
      YC(I)=0.0
      END DO
      NPHASE=1
      GOTO(2022,2051,2061,3000,4000,3200,3300),ITYPE
C
C    DATA FROM D1B(ILL) (ITYPE=1)
C
2022  READ(21,2026)DATE
      READ(21,2026)TXT1
      READ(21,*)I0,NUMOR
      READ(21,2026)TXT1
      READ(21,2026)TXT1
      J=0
      READ(21,2028)A1,(Y(J+NO),NO=1,10)
      J=J+10
      DO 2027 I=2,40
      READ(21,2028)AAA,(Y(J+NO),NO=1,10)
2027  J=J+10
      Y(1)=Y(2)
      Y(400)=Y(399)
      THMIN=2.0*A1
      STEP=0.2
      NPTS=400
      THMAX=THMIN+399*STEP
2026  FORMAT(20A4)
2028  FORMAT(F7.3,10F6.0)
      GOTO 484
C
C    DATA FROM D1A(ILL) (ITYPE=2)
C
2051  READ(21,*,END=99998)THMIN,STEP,THMAX
      NPTS=(THMAX-THMIN)/STEP+1.5
      READ(21,472,END=99998)(IWT(I),Y(I),I=1,NPTS)
 472  FORMAT(10(I2,F6.0))
      GOTO 484
C
C     FREE FORMAT        (ITYPE=3)
C
2061  READ(21,*)THMIN,STEP,THMAX
      NPTS=(THMAX-THMIN)/STEP+1.5
      READ(21,*) (Y(I),I=1,NPTS)
      GOTO 484
C
C    NEW FORMAT D1B,D20   (ITYPE=4)
C
3000  READ(21,1)NSET
   1  format(i5)
      READ(21,2)jdate,noexp,p1a
   2  format(1x,a,2x,a,2x,a)
      READ(21,3)nset1,numor,NSUMAD
   3  format(i3,1x,i6,1X,I4)
      READ(21,4)xmon,tim,THMIN,omega,chi,phi,tr1,tr2,step,tset,tcons,tsamp
   4  format(f13.0,f9.0,1x,10(f8.3,1x))
      READ(21,5)NPTS,(volt(nv),nv=1,5),numc1,numc2
   5  format(i4,1x,5(f9.3,1x),29x,i6,3x,i6)
      j=0
        NPUNT2=NPTS/10
        THMAX=THMIN+(NPTS-1)*STEP
      do i=1,NPUNT2
      READ(21,6)(IWT(j+no),Y(j+no),no=1,10)
      j=j+10
      end do
   6  format(10(I2,F8.0))
      READ(21,7)inum
   7  format(i10)
        GOTO 484
C
C    LIST OF PAIRS (X,Y)   (ITYPE=5)
C
4000    J=1
  11    READ(21,*,END=12) X(J),Y(J)
        J=J+1
        GOTO 11
  12    NPTS=J-1
        IF(NPTS.EQ.0) STOP 'NO POINTS IN THE FILE'
        THMIN=X(1)
        THMAX=X(NPTS)
        STEP=X(2)-X(1)
      GOTO 484
C
C     READ  FORMAT OF D1A,D2B   (ITYPE=6)
C
 3200 READ(21,'(A72)') P1A
      READ(21,34)I1,I2,STEP,I3,I4,I5
  34  FORMAT(2I8,F8.3,3I8)
      READ(21,35)THMIN
  35  FORMAT(F8.3)
      READ(21,36) RMONI
  36  FORMAT(F8.0)
      j=0
        NPUNT2=(18./STEP)
      do i=1,NPUNT2
      READ(21,'(10(I2,F6.0))')(IWT(j+no),Y(j+no),no=1,10)
      IF(Y(J+1).EQ.-1000.) GOTO 999
      j=j+10
      end do
  999      J=J-10
        NPTS=J
        THMAX=THMIN+(NPTS-1)*STEP
      GOTO 484
C
C     READ  FORMAT OF D4,D20L   (ITYPE=7)
C
 3300 READ(21,'(I5,1X,F5.0,1X,A72)')NPTS,TSAMP,P1A
      READ(21,'(5(F7.2,1X,F8.1,6X))')(X(I),Y(I),I=1,NPTS)
      STEP=X(2)-X(1)
      THMIN=X(1)
      THMAX=X(NPTS)
      GOTO 484
C
C  LECTURE OF OBSERVED AND CALCULATED PATTERNS
C
5000      GOTO(484,4002,4004,4005,4007,4100,4200,4300,4400),IFORM
C
C  DATA FROM PAWLEY PROGRAM
C
4002  READ(21,3101)TITLE
      J=0
2035  FORMAT(10F8.0)
      DO I=1,NPUNTO
      READ(21,2035,END=4006)(X(J+K),K=1,10)
      READ(21,2035,END=4006)(Y(J+K),K=1,10)
      READ(21,2035,END=4006)(YC(J+K),K=1,10)
      J=J+10
      END DO
 4006 NPTS=J
      DO I=1,NPTS
        NPO=I
        IF(Y(I).LE.0.0.AND.I.NE.1) Y(I)=Y(I-1)
        IF(YC(I).LE.0.0.AND.I.NE.1) YC(I)=YC(I-1)
      X(I)=X(I)/10000.
        IF(X(I).LT.X(I-1)) THEN
         NPO=NPO-1
         GOTO 4111
        ENDIF
      END DO
 4111 NPTS=NPO
      THMIN=X(1)
      THMAX=X(NPTS)
      STEP=X(2)-X(1)
      NPHASE=1
      GOTO 484
C
C  DATA FROM FullProf PROGRAM
C
 4004 READ(21,3101)TITLE
 3101 FORMAT(20A4)
      READ(21,3102)IFY,IFYC,IFM,IFD,EXPAND,ZER
 3102 FORMAT(4I1,2F9.4)
      READ(21,3103)THMAX,THMIN,STEP,IVERS
 3103 FORMAT(2F8.3,F8.5,I8)
      READ(21,3104)NPHASE,NPTS
 3104 FORMAT(I3,I7)
      READ(21,3105)(IC(I),I=1,NPHASE)
 3105 FORMAT(8I5)
      READ(21,71)(Y(J),J=1,NPTS)
      READ(21,71)(YC(J),J=1,NPTS)
  71  FORMAT(8(F7.0,1X))
      NREF=0
          DO I=1,NPHASE
                NREF=IC(I)+NREF
          END DO
      READ(21,3106)(IREFS(J),J=1,NREF)
      READ(21,3107)(REFS(J),J=1,NREF)
      DO J=1,NREF
      REFS(J)=REFS(J)+ZER
      END DO
 3106 FORMAT(8I10)
 3107 FORMAT(10F8.3)
      NEXC=0
      IF(IVERS.EQ.8.OR.IVERS.EQ.1) THEN
      READ(21,'(I8)') NEXC
      READ(21,'(2F8.2)')(ALOW(I),AHIGH(I),I=1,NEXC)
      DO I=1,NEXC
         NPTLOW=(ALOW(I)-THMIN)/STEP+1.5
         NPTHI=(AHIGH(I)-THMIN)/STEP+1.5
           IF(NPTLOW.LT.1) NPTLOW=1
           IF(NPTLOW.GT.NPTS) NPTLOW=NPTS
           IF(NPTHI.LT.1) NPTHI=1
           IF(NPTHI.GT.NPTS) NPTHI=NPTS
                 DO J=NPTLOW,NPTHI
            YC(J)=0.0
            Y(J)=0.0
            END DO
      END DO
      END IF
      IF(IVERS.NE.8) IVERS=4
C
C  ASK FOR THE POSIBILITY TO ADD A FURTHER CALCULATED PATTERN
C
      WRITE(*,'(A)')'  Add a further calc. pattern (Y/N)? (<CR>=N)'
      READ(*,'(A)') ANS
      IF(ANS.EQ.'Y'.OR.ANS.EQ.'y') THEN
      CLOSE(UNIT=21)
 198  TYPE*,'   Name of the calculated pattern file '
      TYPE*,' (same conditions as the obs-cal pattern) '
      ACCEPT 200,FILEN1
 200  FORMAT(A16)
      OPEN(UNIT=21,NAME=FILEN1,TYPE='OLD',ERR=199,READONLY)
      GOTO 1197
 199  TYPE*,' FILE NON-EXISTENT'
      GOTO 198
1197  READ(21,3101,ERR=201) TITLE
      READ(21,3102,ERR=201)IFY
      READ(21,3103,ERR=201)TH
      READ(21,3104,ERR=201)NP,NPT
      READ(21,3105,ERR=201)II
      READ(21,71,ERR=201)(YCC(J),J=1,NPT)
      IADDP=1
      GOTO 484
      ELSE
      IADDP=0
      GOTO 484
      ENDIF
 201  WRITE(*,'(A)') ' Some error(s) occured reading the file'
      WRITE(*,'(A)') ' No new calculated pattern will be added'
      IADDP=0
      GOTO 484
C
C   DATA FROM NEUFIT PROGRAM
C
4005  READ(21,*)THMIN,STEP,THMAX,NPTS,NREF
      READ(21,*)(Y(J),J=1,NPTS)
      READ(21,*)(YC(J),J=1,NPTS)
      NPHASE=1
      DO I=1,NREF
      READ(21,*)REFS(I),REFI
      END DO
      IC(1)=NREF
      IC(2)=0
      NPHASE=1
      GOTO 484
C
C  DATA FROM ARIT PROGRAM
C

4007  TYPE*,' Number of phases ?'
      READ(*,*,ERR=4007) NPHASE
      IF(NPHASE.LT.1.OR.NPHASE.GT.3) NPHASE=1
      J=1
 270  READ(21,'(I2,1X,I8,2X,3I4)')ICOD,IPOS,I1,I2,I3
      IF(ICOD.EQ.99) GOTO 271
      IREFS(J)=ICOD
      REFS(J)=FLOAT(IPOS)/100.0
      J=J+1
      IF(J.GT.4096) STOP
      GOTO 270
 271  NREF=J
      READ(21,*)THMIN,STEP,THMAX
      THMIN=THMIN/100
      STEP=STEP/100
      THMAX=THMAX/100
      J=0
        NPU=((THMAX-THMIN)/STEP+1.5)/10.0
        DO I=1,NPU
      READ(21,2035)(Y(J+K),K=1,10)
      READ(21,2035)(YC(J+K),K=1,10)
           DO K=1,10
              IF(Y(J+K).LT.-500) GOTO 4008
              IF(YC(J+K).LT.-500) GOTO 4008
           END DO
      J=J+10
      END DO
 4008 NPTS=J-10
      THMAX=THMIN+(NPTS-1)*STEP
      GOTO 484
C
C  DATA FROM PROF2(BNL) PROGRAM
C
 4100 NPHASE=1
      READ(21,1500) IALF,ISTAP,IOMEG
 1500 FORMAT(3I8/)
      THMAX=FLOAT(IOMEG)/100.0
      THMIN=FLOAT(IALF)/100.0
      STEP=FLOAT(ISTAP)/100.0
      NPTS=(THMAX-THMIN)/STEP+1.5
      NLIN=NPTS/10+3
      K=0
      DO 1600 J=1,NLIN
      READ(21,1501)(IOB(I1),I1=1,10),(ICA(I2),I2=1,10)
      IF(IOB(1).EQ.-1000.OR.ICA(1).EQ.-1000) GOTO 1660
      DO 1650 N=1,10
      Y(K+N)=IOB(N)
 1650 YC(K+N)=ICA(N)
      K=K+10
 1600 CONTINUE
 1501 FORMAT(10I8)
 1660 IF(IOB(1).EQ.-1000.AND.ICA(1).EQ.-1000) READ(21,1502) IC(1)
      IF(IOB(1).NE.-1000.AND.ICA(1).EQ.-1000) THEN
      READ(21,1502) IC(1)
      READ(21,1502) IC(1)
      END IF
 1502 FORMAT(I8)
      NREF=IC(1)
      DO 1670 I=1,NREF
      READ(21,1503) IREFS(I),REFS(I)
      REFS(I)=REFS(I)/100.0
 1670 CONTINUE
 1503 FORMAT(I8,F8.1)
      GOTO 484
C
C  DATA FROM MAGREF PROGRAM
C
4200  READ(21,*)THMIN,STEP,THMAX,NREF
      NPTS=(THMAX-THMIN)/STEP+1.5
      READ(21,*) (Y(I),I=1,NPTS)
      DO I=1,NPTS
      YC(I)=Y(I)
      END DO
      NPHASE=1
      DO I=1,NREF
      READ(21,*) REFS(I)
      END DO
      GOTO 484
C
C  DATA FROM DIFFaX PROGRAM
C
4300  I=1
      SUMA=0.0
      IFFAX=0
4301  READ(21,4303,END=4302) X(I),TAB,Y(I),TAB,YC(I)
4303  FORMAT(1X,E12.5,2(A,G13.6))
      SUMA=SUMA+YC(I)
      I=I+1
      GOTO 4301
4302  NPTS=I-1
      THMIN=X(1)
      STEP=X(2)-X(1)
      THMAX=X(NPTS)
      IF(SUMA.GT.0.01) IFFAX=1
      RETURN
C
C  DATA 2THETA, IOBS, YCAL FREE FORMAT
C
4400  I=1
4401  READ(21,*,END=4402) X(I),Y(I),YC(I)
      I=I+1
      GOTO 4401
4402  NPTS=I-1
      THMIN=X(1)
      THMAX=X(NPTS)
      STEP=(X(NPTS)-X(1))/(NPTS-1)
      RETURN
C
C
C
 484  CONTINUE
      IF(IFORM.EQ.2.OR.ITYPE.EQ.5.OR.ITYPE.EQ.7) RETURN
      X(1)=THMIN
      DO I=2,NPTS
      X(I)=THMIN+(I-1)*STEP
      END DO
      RETURN
99998 STOP 'END OF DATA IN UNIT 21'
      END
C----------------------------------------------------------------------------
	SUBROUTINE CHANGE
      CHARACTER ANS*1,ANSTEK*1
      INTEGER  TTY
C
C     SELECT HERE THE TYPE AN SHAPE OF THE OBS-CALC PLOT
C
      COMMON/JNK/IVERS,NEXC,ALOW(30),AHIGH(30),DIFM,KSP,TICK,ANSTEK,
     &IDIF,IADDP,XT,YT,IOB,IFFAX
      TTY=5
  196 WRITE(TTY,'(/A)') '  Change plot parameters (Y/N/Help) (<CR>=N)? '
      READ(TTY,'(A)')ANS
      IF(ANS.EQ.'H'.OR.ANS.EQ.'h') THEN
      TYPE*,'  '
      TYPE*,' The plot parameters are XT,YT,DIFM,TICK,IDIF and KSP:'
      TYPE*,'  '
      TYPE*,'   XT: Dimension (in cm) of the X axis'
      TYPE*,'   YT: Dimension (in cm) of the Y axis'
      TYPE*,'       (default XT = 22.5 cm and YT = 16.95 cm) '
      TYPE*,' DIFM: Y dimension of the area reserved for difference'
      TYPE*,'       pattern and reflection markers (def. DIFM= 4.8 cm)'
      TYPE*,' TICK: Separation (in degrees 2Theta) of small tick '
      TYPE*,'       markers in 2Theta axis (def. value 5.0)'
      TYPE*,'       the minimum value is 0.1 (irrelevant in Q/D axis)'
      TYPE*,' IDIF: Flag to plot(1) or not(0) the difference pattern'
      TYPE*,'  IOB: Flag to plot(1) or not(0) the observed pattern'
      TYPE*,'  KSP: Type of symbols used for Observed pattern: '
      TYPE*,'          1 - Crosses of Y-size proportional to sigma(Y) '
      TYPE*,'          2 - + fixed size determined by program (default)'
      TYPE*,'          3 - *    "       '
      TYPE*,'          4 - o    "       '
      TYPE*,'          5 - x    "       '
      TYPE*,'  '
      GOTO 196
      ENDIF
      IF(.NOT.(ANS.EQ.'Y'.OR.ANS.EQ.'y')) RETURN
 197  WRITE(*,'(A)') '  Change the dimension of the whole plot? (Y/N)'
      READ(TTY,'(A)')ANS
      IF(ANS.EQ.'Y'.OR.ANS.EQ.'y') THEN
      WRITE(*,'(A)') '  Give XT and YT in cm '
      READ(*,*,ERR=197) XT,YT
      IF(XT.LT.5.0) XT=10.0
      IF(YT.LT.4.0) YT=6.0
      ENDIF
 195  WRITE(*,'(A)') '  Give DIFM,TICK,IDIF,IOB and KSP'
      READ(*,*,ERR=195) DIFM,TICK,IDIF,IOB,KSP 
      IF(DIFM.GT.YT/2.5) DIFM=YT/3.0
      IF(KSP.LT.1.OR.KSP.GT.5) KSP=2
	RETURN
	END
